;;; This file was automatically generated by SWIG (http://www.swig.org).
;;; Version 1.3.40
;;;
;;; Do not make changes to this file unless you know what you are doing--modify
;;; the SWIG interface file instead.

(in-package :llvm)


(cffi:defcfun ("CLLLVM_LLVMInitializeNativeTarget" CLLLVM_LLVMInitializeNativeTarget) :int)

(cffi:defcfun ("CLLLVM_LLVMModuleProviderGetModule" CLLLVM_LLVMModuleProviderGetModule) LLVMModuleRef
  (modprovider LLVMModuleProviderRef))

(cffi:defcfun ("CLLLVM_LLVMParseAssemblyString" CLLLVM_LLVMParseAssemblyString) LLVMModuleRef
  (AsmString :string)
  (M LLVMModuleRef)
  (Context LLVMContextRef))

(cffi:defcfun ("CLLLVM_LLVMIntPtrTypeInContext" CLLLVM_LLVMIntPtrTypeInContext) LLVMTypeRef
  (Context LLVMContextRef)
  (TD LLVMTargetDataRef))

(cffi:defcfun ("CLLLVM_LLVMDumpModuleToString" CLLLVM_LLVMDumpModuleToString) :string
  (module LLVMModuleRef))

(cffi:defcfun ("CLLLVM_LLVMDumpTypeToString" CLLLVM_LLVMDumpTypeToString) :string
  (type LLVMTypeRef))

(cffi:defcfun ("CLLLVM_LLVMDumpValueToString" CLLLVM_LLVMDumpValueToString) :string
  (value LLVMValueRef))

(cffi:defcfun ("CLLLVM_LLVMAddFunctionAttr" LLVMAddFunctionAttr) :void
  (Fn LLVMValueRef)
  (PA LLVMAttribute))

(cffi:defcfun ("CLLLVM_LLVMRemoveFunctionAttr" LLVMRemoveFunctionAttr) :void
  (Fn LLVMValueRef)
  (PA LLVMAttribute))

(cffi:defcfun ("CLLLVM_LLVMAddRetAttr" LLVMAddRetAttr) :void
  (Fn LLVMValueRef)
  (PA LLVMAttribute))

(cffi:defcfun ("CLLLVM_LLVMRemoveRetAttr" LLVMRemoveRetAttr) :void
  (Fn LLVMValueRef)
  (PA LLVMAttribute))

(cffi:defcfun ("CLLLVM_LLVMGetRetAttr" LLVMGetRetAttr) LLVMAttribute
  (Fn LLVMValueRef))

(cffi:defcfun ("CLLLVM_LLVMConstIntOfBigVal" LLVMConstIntOfBigVal) LLVMValueRef
  (IntTy LLVMTypeRef)
  (numWords :unsigned-int)
  (bigVal :pointer))

(cffi:defcfun ("CLLLVM_AddPrintAsmPass" CLLLVM_AddPrintAsmPass) :void
  (PM LLVMPassManagerRef)
  (Banner :string))

(defun LLVMConstInt (Ty Num)
  (declare (type integer Num))
  ;; If the type is <= 64 bits, it's easy: we can just pass the
  ;; (truncated) number into %LLVMConstInt directly.  Otherwise,
  ;; convert the number to a bunch of 64-bit words, and pass those to
  ;; LLVMConstIntOfBigVal.
  (let ((bitwidth (LLVMGetIntTypeWidth Ty)))
    (if (< bitwidth 65)
        (%LLVMConstInt Ty (logand Num #xffffffffffffffff) 0)
        (let ((n-words (ceiling bitwidth 64)))
          (cffi:with-foreign-object (array :unsigned-long-long n-words)
            (loop for i from 0 below n-words
                  do
                  (setf (cffi:mem-aref array :unsigned-long-long i)
                        (logand Num #xffffffffffffffff))
                  (setf Num (ash Num -64)))
            (LLVMConstIntOfBigVal Ty n-words array))))))



